#!/usr/bin/env python

import os, sys
import urllib2, urllib
from sgmllib import SGMLParser

CHANGSHA_URL = 'http://pm25.moji001.com/aqi/index-47.html'
PART_URL = 'http://pm25.moji001.com/aqi/'
#CITY = '\xe5\x85\xb0\xe5\xb7\x9e'

PROJECT_ROOT_DIRECTORY = os.path.abspath(
    os.path.dirname(os.path.dirname(os.path.realpath(sys.argv[0]))))
PM_CITY_LIST_FILE = os.path.join(PROJECT_ROOT_DIRECTORY, 'src/city_list.txt')

PM_DIC = {'figure':'','explain':'','cue':''}

class GetCodeUrl:
	def change_str(self, cityplace):
		tran_unicode_tmp = unicode(cityplace, "utf-8")
		return tran_unicode_tmp
	def get_url(self,cityplace):
		all_url = ''
		cs_string = self.read_from_url(CHANGSHA_URL)
		city_url = get_city_url(cs_string,cityplace)
		if city_url != 'NA':
			all_url = PART_URL + city_url
		#print all_url
		return all_url

	def read_from_url(self, url):
		request = urllib2.Request(url, headers={'User-Agent' : 'Magic Browser'})
		f = urllib2.urlopen(request)
		code_string = f.read()
		return code_string

class GetCue (SGMLParser):
	def reset(self):
		self.Cue = []
		self.flag = False
		self.getdata = False
		self.verbatim = 0
		SGMLParser.reset(self)
	def start_div(self, attrs):
		if self.flag == True:
			self.verbatim += 1
			return
		for k,v in attrs:
			if k == 'class' and v == 'pmleftPrompt':
				self.flag = True
				return
	def end_div(self):
		if self.verbatim == 0:
			self.flag = False
		if self.flag == True:
			self.verbatim -=1
	def start_p(self, attrs):
		if self.flag == False:
			return
		self.getdata = True
	def end_p(self):
		if self.getdata:
			self.getdata = False
	def handle_data(self, text):
		if self.getdata:
			self.Cue.append(text)
			PM_DIC['cue'] = self.Cue
	def printID(self):
		for i in self.Cue:
			print i

class GetFigure(SGMLParser):
	def reset(self):
		self.Figure = []
		self.flag = False
		self.getdata = False
		self.verbatim = False
		SGMLParser.reset(self)
	def start_div(self, attrs):
		if self.getdata == True:
			self.verbatim += 1
			return
		for k,v in attrs:
			if k == 'class' and v == 'pmaqiVLeft':
				self.getdata = True
				return
	def end_div(self):
		if self.getdata:
			self.getdata = False
	def handle_data(self, text):
		if self.getdata:
			self.Figure.append(text)
			PM_DIC['figure'] = self.Figure
	def printID(self):
		for i in self.Figure:
			print i

class GetExplain:
	def my_handle_data(self, json_string):
		tmp_str=json_string
		urlindex = tmp_str.find('<div class=\"pmaqiVRPrompt\">')
		urlend = tmp_str[urlindex:].find('</div>')
		div_str = tmp_str[urlindex:urlindex + urlend]
		urlindex = -1
		urlend = -1
		urlindex = div_str.find('">')
		urlend = div_str.find('<!')
		explain_tmp = div_str[urlindex + 2: urlend ]
		PM_DIC['explain'] = explain_tmp

def get_city_url(cs_string,cityplace):
	city_url = ''
	tmp_str = cs_string
	urlindex = tmp_str.find('</a></span></div>')
	urlend = tmp_str[urlindex:].find('<div class="pmleftAQItitle">')
	city_list_str_tmp = tmp_str[urlindex:urlindex + urlend]
	urlindex = -1
	urlend = -1
	urlindex = city_list_str_tmp.find('<a class="city_links"')
	urlend = city_list_str_tmp[urlindex:].find('</div>')
	city_list_str_no = city_list_str_tmp[urlindex:urlindex + urlend]
	city_list_str_ok = city_list_str_no.replace('\t\t\t','')
	urlend = -1
	urlend = city_list_str_ok.find('\t')
	city_list_str = city_list_str_ok[:urlend - 1]
	city_list_list = city_list_str.split('\n')
	flag = 0
	for city in city_list_list:
		if cityplace in city:
			city_url = city.split('"')[3]
			flag = 1
			break
	if flag == 0:
		city_url = 'NA'
	return city_url

def resault():
	PM_DIC['cue'] = ''.join(PM_DIC['cue'])
	PM_DIC['figure'] = ''.join(PM_DIC['figure'])

	x = PM_DIC['explain']
	print x
	y = PM_DIC['cue']
	print y
	z = PM_DIC['figure']
	print z

def get_pm_from_city(cityplace):
    try:
        listerg = GetCodeUrl()
        listerc = GetCue()
        listerf = GetFigure()
        listere = GetExplain()
        url =listerg.get_url(cityplace)
        if url == '' :
            PM_DIC['explain'] = 'NA'
            PM_DIC['cue'] = 'NA'
            PM_DIC['figure'] = 'NA'
            return PM_DIC
        json_string = listerg.read_from_url(url)
        listerc.feed(json_string)
        listerf.feed(json_string)
        listere.my_handle_data(json_string)
        return PM_DIC
    except Exception as e:
        print(e)

#if __name__ == "__main__":
#	abc = get_pm_from_city(cityplace)
#	print abc
